package cn.com.infosec.ocsp;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERNull;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.ocsp.CertID;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;
import cn.com.infosec.jce.PrincipalUtil;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.PublicKey;
import java.security.cert.X509Certificate;

public class CertificateID {
   public static final String HASH_SHA1 = "1.3.14.3.2.26";
   private CertID id;

   public CertificateID(CertID id) {
      this.id = id;
   }

   public CertificateID(String hashAlgorithm, X509Certificate issuerCert, BigInteger number, String provider) {
      CertificateID var10000 = this;
      String var10001 = hashAlgorithm;
      String var10002 = provider;
      super();

      Exception var19;
      label65: {
         boolean var20;
         MessageDigest var21;
         try {
            var21 = MessageDigest.getInstance(var10001, var10002);
         } catch (Exception var11) {
            var19 = var11;
            var20 = false;
            break label65;
         }

         MessageDigest var12 = var21;

         MessageDigest var10003;
         X509Certificate var10004;
         AlgorithmIdentifier var10005;
         X509Certificate var22;
         try {
            var22 = issuerCert;
            var10003 = var12;
            var10004 = issuerCert;
            var10005 = new AlgorithmIdentifier;
         } catch (Exception var10) {
            var19 = var10;
            var20 = false;
            break label65;
         }

         AlgorithmIdentifier issuerCert1 = var10005;

         DEROctetString var24;
         try {
            var10005.<init>(new DERObjectIdentifier(hashAlgorithm), new DERNull());
            var10003.update(PrincipalUtil.getSubjectX509Principal(var10004).getEncoded());
            var24 = new DEROctetString;
         } catch (Exception var9) {
            var19 = var9;
            var20 = false;
            break label65;
         }

         DEROctetString hashAlgorithm1 = var24;

         PublicKey var23;
         try {
            var24.<init>(var12.digest());
            var23 = var22.getPublicKey();
         } catch (Exception var8) {
            var19 = var8;
            var20 = false;
            break label65;
         }

         PublicKey provider1 = var23;

         DEROctetString var25;
         try {
            var21.update(SubjectPublicKeyInfo.getInstance((new ASN1InputStream(provider1.getEncoded())).readObject()).getPublicKeyData().getBytes());
            var25 = new DEROctetString;
         } catch (Exception var7) {
            var19 = var7;
            var20 = false;
            break label65;
         }

         DEROctetString provider2 = var25;

         DERInteger var26;
         try {
            var25.<init>(var12.digest());
            var26 = new DERInteger;
         } catch (Exception var6) {
            var19 = var6;
            var20 = false;
            break label65;
         }

         DERInteger var13 = var26;

         try {
            var26.<init>(number);
            var10000.id = new CertID(issuerCert1, hashAlgorithm1, provider2, var13);
            return;
         } catch (Exception var5) {
            var19 = var5;
            var20 = false;
         }
      }

      Exception var14 = var19;
      throw new OCSPException("problem creating ID: " + var14, var14);
   }

   public CertificateID(String hashAlgorithm, X509Certificate issuerCert, BigInteger number) {
      this(hashAlgorithm, issuerCert, number, "INFOSEC");
   }

   public String getHashAlgOID() {
      return this.id.getHashAlgorithm().getObjectId().getId();
   }

   public byte[] getIssuerNameHash() {
      return this.id.getIssuerNameHash().getOctets();
   }

   public byte[] getIssuerKeyHash() {
      return this.id.getIssuerKeyHash().getOctets();
   }

   public BigInteger getSerialNumber() {
      return this.id.getSerialNumber().getValue();
   }

   public CertID toASN1Object() {
      return this.id;
   }

   public boolean equals(Object o) {
      if (!(o instanceof CertificateID)) {
         return false;
      } else {
         CertificateID var10000 = this;
         CertificateID var2 = (CertificateID)o;
         return var10000.id.getDERObject().equals(var2.id.getDERObject());
      }
   }

   public int hashCode() {
      return this.id.getDERObject().hashCode();
   }
}
